/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Weitere Möglichkeiten der Bildbearbeitung mit processing. Als Übungsaufgabe gedacht.
//Um eine Erweiterung durch andere Filter zu ermöglichen, wurden geeignete Klassen angelegt
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
private boolean fertig = false;
protected boolean tasteGedrueckt = false;
protected PImage  bildOriginal, bildFertig;// bildAusgewaehlt; 
private int[][] tempMatrix; 
protected int h,w, wahl;
protected int g = 1; //Stärke des Gaußfilters
private int d = 0; //Verschiebung von bildTrans in x und -y Richtung
private float werte = 2.2;//2.2;//Werte-Verschiebung im Histogramm, wobei schwarz schwarz bleibt
protected float faktor =1;//Geeignet, um bei scharfzeichnen oder Relief das Bild heller(faktor <2) oder dunkler zu machen
private float saettigungFaktor = 0;
private float a = 1;
private int w1, h1;//Anzahl der Pixel in Breite und Höhe am Bildschirm

Gauss blur;
BlendingFilter subraktion;
MatrixCutter cutLU, cutRO;
EinfachFilter filter;
Sobel edge;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup(){  
    size(800,600);
    background(0);
  
    textSize(14);
    text("Filter-Tool", 40, 40); 
    text("Verwenden Sie die Tasten:", 40, 100); 
    text("<1> für das Schärfen des Bildes (unscharf maskieren).",40, 140);  
    text("<2> für die Verwandlung des Bildes in ein Relief.",40,180);
    text("<3> für die Aufhellung des Bildes - aber schwarz bleibt schwarz.", 40,220);
    text("<4> für die Anwendung des Gaußfilters, um schonend weichzuzeichnen ", 40, 260);   
    text("<5> für die Verstärkung der Farben.", 40, 300); 
    text("<6> für das Extrahieren der Kanten. ", 40, 340); 
    text("Das bearbeitete Bild wird automatisch im Programmordner gespeichert und kann dort erneut geladen werden.", 40, 380); 
    text("...und die gewünschte jpg-Bilddatei wählen.",40,420);
    text("Bei sehr großen Bildern kann der Relieffilter(2) 1-2 Minuten dauern, denn es wird sehr, sehr viel gerechnet!",40,460);  
    
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void draw() {
  if(tasteGedrueckt == true){
    switch(wahl){
     case 1: 
      bildFertig =bildScharfzeichnen(bildOriginal);
      break;
    case 2: 
      bildFertig = bildRelief(bildOriginal);
      break;
    case 3: 
      bildFertig = bildSpreizen(bildOriginal);
      break;
    case 4: 
      bildFertig = bildWeichzeichnen(bildOriginal);
      break;
    case 5:
      bildFertig = bildSaettigung(bildOriginal);
      break;
    case 6:
      bildFertig = bildKanten(bildOriginal);
      break;
   }
  }
  if(fertig){ 
    //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
    //Verbleibende Seite proportional vergrößert/verkleinert
    image(bildFertig,0,0,w/a,h/a);
    bildFertig.save("bildBearbeitet.jpg");
    fertig = false;
  }
}
///////////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == '1') {//Bild schärfen
      colorMode(RGB,255,255,255);
      g=1; d=0; wahl = 1;
      faktor = 2;
      bildWaehlen();
  } 
  if (key == '2') {//Relief 
     colorMode(RGB,255,255,255);
     d=2;faktor = 1.4;//faktor = 2;
     g = 1;  wahl =2;  
     bildWaehlen();
  }
  if (key == '3') {//Bild aufellen  
     colorMode(RGB,255,255,255);
     d=0;
     g = 0; werte = 1.1;//g=0;werte=1.2;
     wahl =3;
     bildWaehlen() ;
  }
   if (key == '4') {//Bild Gauß weichzeichnen 
     colorMode(RGB,255,255,255);
     d=0;
     g = 1; werte = 1;
      wahl =4;
     bildWaehlen();
   }
   if (key == '5') {//Bild Sättigung erhöhen
     colorMode(HSB,360,100,100);
     d=0;
     g = 0; werte = 1;
     wahl =5;
     saettigungFaktor = 1.3;
     bildWaehlen();
   }
    if (key == '6') {//Bild Kanten finden
    colorMode(RGB,255,255,255);  
     wahl =6; 
     bildWaehlen();
   }
    if (key == 's') {
      bildFertig.save("bildBearbeitet.jpg");
      noLoop();
  }  
}

/////////////////////////////////////////////////////////////////////// 
//Die folgenden beiden Methoden bewirken, dass ein Lade-Dialog erscheint  
////////////////////////////////////////////////////////////////////////      
 void bildWaehlen(){
      selectInput("", "bildAusgewaehlt");
        while (bildOriginal == null) {
        delay(200);
      }
      loop();
      w =bildOriginal.width; h = bildOriginal.height  ;
      //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
      //Verbleibende Seite proportional vergrößert/verkleinert
      if(w>=h){  
        a =(float)w/800; 
        w1 = int( w/a); println(w1);
        h1 = int((float)h/a); println(h1);
      }else{
        a = (float)h/800; 
        h1 =int( h/a);  
        w1 = int((float)w/a);
      }   
      surface.setSize(w1,h1);
      tasteGedrueckt = true;
 }
///////////////////////////////////////////////////////////////////////////// 
  void bildAusgewaehlt(File auswahl)
    {
      bildOriginal = loadImage(auswahl.getAbsolutePath());
    }
/////////////////////////////////////////////////////////////////////
//Funktion, die ein Pixelbild in eine Matrix verwandelt
public int[][] matrixVonBild(PImage bildEingabe){
  
  PImage bild = bildEingabe;
  int h = bild.height;
  int w = bild.width;
  int[][] bearbeitetMatrix = new int[w][h];
  for(int i = 0; i < w; i++){
    for(int j = 0; j < h; j++){
     bearbeitetMatrix[i][j] = bild.pixels[i + j*w];
    } 
 }
 return bearbeitetMatrix;
}
////////////////////////////////////////////////////////////////////////
//Matrix in Bild verwandeln
public PImage bildVonMatrix(int[][] matrix){
  
   int[][] bearbeitetMatrix = matrix;
   int zeilen =bearbeitetMatrix[0].length ;
   int spalten = bearbeitetMatrix.length;
    PImage bild = createImage(spalten,zeilen,RGB);
   for(int i = 0; i < spalten; i++){
     for(int j = 0; j < zeilen; j++){
       bild.pixels[i + j*spalten] = bearbeitetMatrix[i][j];
     } 
  }
 return bild;
}
/////////////////////////////////////////////////////////////////////
//Weichzeichnen mit 7x7 Gaußmatrix
public PImage bildWeichzeichnen(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Gauß-Weichzeichnen 
   int[][] bearbeitetMatrix = new int[w][h];  
    tempMatrix = new int[w][h]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    blur   = new Gauss(bearbeitetMatrix);
    bearbeitetMatrix = blur.gaussAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true;  
    return bildBearbeitet;   
 }

////////////////////////////////////////////////////////////////////////////////
//"Werte" werden angehoben. Heller machen und trotzdem schwarz erhalten
///////////////////////////////////////////////////////////////////////////////
public PImage bildSpreizen(PImage bild){
    bildOriginal = bild;
    filter = new EinfachFilter(bildOriginal);
    PImage bildBearbeitet = filter.bildSpreizen();
     tasteGedrueckt = false;
    fertig = true;   
    
    return bildBearbeitet;
 }
 
///////////////////////////////////////////////////////////////////////////////// 
//Scharfzeichnen durch "unscharf maskieren"
public PImage bildScharfzeichnen(PImage bild) {
    PImage originalBild = bild;
    PImage bildBearbeitet;
    PImage bildKopie = originalBild.copy();  
    PImage bildBlur = createImage(w,h,RGB);
    bildBlur = bildWeichzeichnen(bildKopie);
    int[][]blurMatrix = matrixVonBild(bildBlur);
    int[][]tempMatrix = matrixVonBild(bild);
    subraktion = new BlendingFilter(blurMatrix, tempMatrix);
    bildBearbeitet = bildVonMatrix(subraktion.matrixBlending());   
    tasteGedrueckt = false;
    fertig = true;   
    
    return bildBearbeitet;
}

/////////////////////////////////////////////////////////////////////////// 
//Unscharfe Kopie herstellen, verschieben und dann  Originalbild blending durch Subraktioen
public PImage bildRelief(PImage bild){
    //Ist d>0 müssen die Bilder für das Blending ausgeschnitten werden
    int[][] blurCutM = new int[w-d][h-d];
    int[][] tempCutM = new int[w-d][h-d];
    PImage bildOriginal = bild;
    PImage bildBearbeitet = createImage(w-d,h-d,RGB);
    PImage bildBlur = createImage(w,h,RGB); 
    bildBlur = bildWeichzeichnen(bildOriginal);
    int[][] blurMatrix = matrixVonBild(bildBlur);
    int[][] tempMatrix = matrixVonBild(bildOriginal);  
    cutLU = new MatrixCutter(blurMatrix,d);
    blurCutM = cutLU.cutMatrixLU();
    cutRO = new MatrixCutter(tempMatrix,d);
    tempCutM = cutRO.cutMatrixRO();
    subraktion = new BlendingFilter(blurCutM, tempCutM);
    bildBearbeitet = bildVonMatrix(subraktion.matrixBlending());
    tasteGedrueckt = false;
    fertig = true;    
    
    return bildBearbeitet;
} 

//////////////////////////////////////////////////////////////////////////////////// 
//Farbmodell HSB nutzen, um auf einfache Weise die Sättigung anzuheben.
public PImage bildSaettigung (PImage bild){
    bildOriginal = bild;
    filter = new EinfachFilter(bildOriginal);
    PImage bildBearbeitet= filter.bildSaettigung();
    tasteGedrueckt = false;
    fertig = true; 
    
    return bildBearbeitet;
}
////////////////////////////////////////////////////////////////////////////////////// 
 
 /////////////////////////////////////////////////////////////////////
//Kanten finden mit zwei Matrizen
public PImage bildKanten(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Kanten finden
   int[][] bearbeitetMatrix = new int[w][h];  
    tempMatrix = new int[w][h]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    edge   = new Sobel(bearbeitetMatrix);
    bearbeitetMatrix = edge.sobelAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true; 
  
    return bildBearbeitet;   
 }
 